#---------------------------------------------------------------------------------------
# MS+CA Saturday, April 22, 2006 
# last 11-07-07 :... is taken out from barplot 
histDist <- function(y, 
                  family = NO, 
                    freq = NULL,
                    xmin = NULL, 
                    xmax = NULL,
               g.control = gamlss.control(),
                 density = FALSE,
                    main = NULL,
                      ... )
{
 #gamlss.bi.list <- c("BI", "Binomial", "BB", "Beta Binomial") # take it out later
             FA <- as.gamlss.family(family)    
          fname <- FA$family[1]
       #     FC <- call(fname) 
       #     FA <- eval(FC)
           dfun <- paste("d",fname,sep="")
           lpar <- length(FA$parameters)
       typeDist <- FA$type
 
 switch(typeDist, 
     "Continuous"=
           {
         extra <- (max(y,na.rm = TRUE)-min(y, na.rm = TRUE))/5
          xmin <- if (is.null(xmin))  min(y,na.rm = TRUE)-extra else xmin
          xmax <- if (is.null(xmax))  max(y,na.rm = TRUE)+extra else xmax
           # for the possitive distributions start from 0.001  
           if (!FA$y.valid(xmin)) xmin <- 0.001
           if (!FA$y.valid(xmax)) xmax <-0.999 # for the beta      y
                x1 <- seq(xmin,xmax,length=101)
           },
      "Discrete" =
           {
            if (fname %in% .gamlss.bi.list)# if binomial
              {
               if (NCOL(y) == 1) 
                 {
                #  if (is.factor(y))   
                   x1 <- c(0,1)
                   bd <- rep(1, 2)
                  # y1 <- y 
                 }
                else                 
                 {
                 if (any(abs(y - round(y)) > 0.001)) {warning("non-integer counts in a binomial GAMLSS!")}
                 bd <- y[, 1] + y[, 2]
                 y1 <- y[, 1]
                 if (any(y1 < 0 | y1 > bd)) stop("y values must be 0 <= y <= N")
               xmin <- if (is.null(xmin))  
                           {if (all(bd==bd[1])) min(y1, na.rm = TRUE) else 0 }
                       else xmin    
               xmax <- if (is.null(xmax)) 
                           {if (all(bd==bd[1])) max(bd ,na.rm = TRUE) else 1 }
                       else xmax
                 x1 <- seq(xmin,xmax,by=1)
                 }
              }
            else
              { # if other discrete
          xmin <- if (is.null(xmin))  min(y,na.rm = TRUE) else xmin
          xmax <- if (is.null(xmax))  max(y,na.rm = TRUE) else xmax
            x1 <- seq(xmin,xmax,by=1)     
              }
           },
      "Mixed"=
           {
              stop("Mixed distributions are not implemented yet")
           })          
           # fit the model           
          mod <- if (is.null(freq)) 
                  {  # no frequencies
                  gamlss(y~1, family=FA, control=g.control, ...)
                  }
               else
                  { # with frequencies
                  .freq <<-freq
                  gamlss(y~1, weights=.freq, family=FA, control=g.control, ...)
                  }  
           # get the pdf
     switch(lpar, 
          "1" =  {
             newcall <- if ((fname %in% .gamlss.bi.list)) 
                               call(dfun,x1, mu = fitted(mod)[1], bd=bd[1] )
                        else   call(dfun,x1, mu = fitted(mod)[1])
                 },
          "2" =  {
             newcall <- if ((fname %in% .gamlss.bi.list))
                         {  
  call(dfun,x1, mu = fitted(mod)[1],sigma = fitted(mod,"sigma")[1], bd=bd[1])

                         }  
                       else                            
                         {
                            call(dfun,x1, mu = fitted(mod)[1], sigma = fitted(mod,"sigma")[1])  
                         }
                 },
          "3" = 
                 {
             newcall <-call(dfun,x1, mu = fitted(mod)[1], 
                                  sigma = fitted(mod,"sigma")[1], 
                                     nu = fitted(mod,"nu")[1])
                },
          "4" =
                {
             newcall <-call(dfun, x1, mu = fitted(mod)[1], 
                                   sigma = fitted(mod,"sigma")[1],
                                      nu = fitted(mod,"nu")[1],
                                     tau = fitted(mod,"tau")[1])
                })
switch(typeDist,  
    "Continuous"=  
              { 
                y1 <- eval(newcall)
                mm <- c(xmin,xmax)
           #===================================================================
           #MIKIS functions in version of histDist (incl. the discrete case) 
           #truehist(y, xlim = mm, main=main, ...)   #MIKIS OLD function
           #lines(x1,y1, col="blue3") #MIKIS OLD function
           #===================================================================
           #Poppy's Function -  Date: Friday 21, 2006 at 13:46
           #main1 <- paste("Histogram of y-variable and ", sep = "") #main <- paste("Histogram of y and a fitted (GAMLSS family), ", family," distribution to y", sep = "")
           #main2 <- paste("the fitted ", FA$family[2]," distribution to y-variable", sep = "") #main <- paste("Histogram of y and a fitted (GAMLSS family), ", family," distribution to y", sep = "")
           # main <- c(main1, main2) 
              main <-  if (is.null(main))  
                      paste("Histogram of the ", deparse(substitute(y)), " and the fitted ", FA$family[2]," distribution", sep = "")
                      else main
              if (!is.null(freq)) y <- rep(y,freq) # in case frequencies are used
            truehist(y, xlim = mm, main = main, col="gray", lty=3, border="blue", fg=rainbow(12)[9],  
                        col.main = "blue4", col.lab = "blue4",col.axis = "blue", ...)#Poppy's Function
            lines(x1, y1, col = "red", col.axis = "blue", col.main = "blue4", col.lab = "blue4", 
                       lwd=2,fg = gray(0.7))
            if (density==TRUE) 
                 { dens<-density(y)
                  lines(dens$x, dens$y, col="blue") 
                 }
                   
           #===================================================================
              },
      "Discrete"=
              {  
               if (fname %in% .gamlss.bi.list) # if binomial 
                  {                  
                      if (all(bd==bd[1]))     # binary + equal bd
                        { 
                        y1 <- eval(newcall) # find the fitted values 
                        tabley <- if (NCOL(y) == 1) table(y) else  table(y[,1])
                        dft <- data.frame(tabley)# get the table            
                        r<-barplot(tabley/sum(tabley), fg = "blue", col="gray", axis.lty=1, 
                                     border="blue", col.axis = "blue4", col.main = "blue4", 
                                     col.lab = "blue4")
                        yy1 <- y1[ x1%in%dft[[1]]] # this is to make sure that we have as many points as in the bar plot
                        lines(r, yy1, type='h', col = "red",  lwd=2, col.axis = "blue", 
                                    col.main = "blue4", col.lab = "blue4", fg = gray(0.7))  
                        points(r, yy1,  col="red", pch=21, lwd=2,col.axis = "blue") # extra points  
                        }
                      else  
                        {
                        mm <- c(xmin, xmax)
                        main <- paste("proportions of ", deparse(substitute(y)), sepp = "")
                        truehist(y1/bd, xlim = mm, xlab="proportions", col="gray", lty=3, border="blue", 
                                 col.axis = "blue",col.main = "blue4", col.lab = "blue4", main=main,
                                 fg=rainbow(12)[9], ...)#P
                        #plot(y1/bd~I(y1/bd), type="h", xlim=mm, main=main)
                        #points(y1/bd, y1/bd,  cex= bd/mean(bd))
                        lines( fitted(mod), rep(1,length(fitted(mod))), type="h", col="red" )
                        points(fitted(mod), rep(0, length(fitted(mod))), col = "red", pch=25)
                        points(fitted(mod),rep(1,length(fitted(mod))),   col="red", pch=24)
                        }

                }  
             else
                {
                 y1 <- eval(newcall) # find the fitted values 
                 fy <- if (is.null(freq)) factor(y,level=x1) else factor(rep(y,freq),level=x1)
                dft <-data.frame(tabley<- xtabs(~fy))# get the table    
               #===================================================================
               #MIKIS functions in version of histDist (incl. the discrete case)
               #r <- barplot(tabley/sum(tabley), col="lightblue",  ...)## rainbow(20))#rainbow(20
               #yy1<- y1[ x1%in%dft[[1]]] # this is to make sure that we have as many points as in the bar plot
               #lines(r,  yy1, type='h', col="red", lwd=3) # fitted lines 
               #points(r, yy1,  col="red", pch=21, lwd=3) # extra points
               #===================================================================
               #Poppy's Function -  Date: Thursday 20, 2006 at 13:46
            # main1 <- paste("Histogram of y-variable and ", sep = "") #main <- paste("Histogram of y and a fitted (GAMLSS family), ", family," distribution to y", sep = "")
            # main2 <- paste("the fitted ", FA$family[2]," distribution to y-variable", sep = "") #main <- paste("Histogram of y and a fitted (GAMLSS family), ", family," distribution to y", sep = "")
            #  main <- c(main1, main2)
               main <-  if (is.null(main))  
                      paste("Barplot of the ", deparse(substitute(y)), " and the fitted ", FA$family[2]," distribution", sep = "")
                      else main 
                 r <-  barplot(tabley/sum(tabley), 
                                    fg = "blue", col="gray", axis.lty=1, 
                                    border="blue", col.axis = "blue4",col.main = "blue4", 
                                    col.lab = "blue4", main=main) 
                      #if (is.null(freq)) 
                      #    { barplot(tabley/sum(tabley), 
                      #              fg = "blue", col="gray", axis.lty=1, 
                      #              border="blue", col.axis = "blue4",col.main = "blue4", 
                      #              col.lab = "blue4", main=main, ...)
                      #    }
                      #  else
                      #    {
                      #      barplot(freq/sum(freq),  names.arg = y, 
                      #              fg = "blue", col="gray", axis.lty=1, 
                      #              border="blue", col.axis = "blue4",col.main = "blue4", 
                      #              col.lab = "blue4", main=main, ...)
                      #    }        
                            yy1<- y1[ x1%in%dft[[1]]] # this is to make sure that we have as many points as in the bar plot
                            lines(r, yy1, type='h', col = "red",  lwd=2, col.axis = "blue", 
                                    col.main = "blue4", col.lab = "blue4", fg = gray(0.7))  
                            points(r, yy1,  col="red", pch=21, lwd=2,col.axis = "blue") # extra points  
                 }       
              },
        "Mixed"=
              {
              stop("Mixed distributions are not implemented yet")
              }) 
         on.exit(if (!is.null(freq)) rm(.freq,pos=1))          
            mod
}
                 
