#----------------------------------------------------------------------------------------
#rand <- sample(2, 610, replace=T, prob=c(0.6,0.4))
#----------------------------------------------------------------------------------------
VGD <-function(formula = NULL, 
             sigma.fo =~1, 
                nu.fo =~1, 
               tau.fo =~1, 
                 data = NULL,
               family = NO,  
              control = gamlss.control(trace=FALSE),
                 rand = NULL,
                 ...)
 {
       fname <- as.gamlss.family(family)
        dfun <- paste("d", fname$family[[1]],sep="")
        lpar <- length(fname$parameters)
        if (is.null(formula)) stop("no formula is set in VGD")
        if (is.null(rand)) stop("no subset is set in VGD")
        if ( any(!rand%in%c(1,2))) stop("rand values should ne 1 or 2")
        if (is.null(data)) stop("the data argument is needed in VGD")
      dataor <- subset(data, rand==1)
      datava <- subset(data, rand==2)    
          m1 <- gamlss(formula=formula, sigma.fo=sigma.fo, nu.fo=nu.fo, tau.fo=tau.fo,
                      data=dataor, family=family, control=control, ...) #
         nmu <- predict(m1,newdata=datava, type="response", data=dataor)
     if ("sigma"%in% names(fname$par))  
      nsigma <- predict(m1,newdata=datava, type="response", data=dataor,what="sigma")
     if (  "nu" %in% names(fname$par))     
         nnu <- predict(m1,newdata=datava, type="response", data=dataor,what="nu")
     if ( "tau" %in% names(fname$par))    
        ntau <- predict(m1,newdata=datava, type="response", data=dataor,what="tau")
         ny <-  model.extract(model.frame(formula,data=datava),"response")
        # ny <- datava$y # corrected Monday, November 6, 2006 DS
      if(lpar==1) 
       {
       devi <-call(dfun, y= ny, mu = nmu, log=TRUE) 
       }
      else if(lpar==2)
       {
       devi <-call(dfun, y=ny, mu = nmu, sigma = nsigma, log=TRUE) 
       }
      else if(lpar==3)
       {
       devi <-call(dfun, y=ny, mu = nmu, sigma = nsigma, nu = nnu, log=TRUE)
       }
      else 
       {
       devi <-call(dfun, y=ny, mu = nmu, sigma = nsigma,nu = nnu,tau = ntau, log=TRUE)
       }
       dev <- -2*sum(eval(devi))
     dev
 }
    
     
